//Jamagic's Temporary resource files eraser v1.2
//by Giovanni@Cardona.com feb-2001, mar-2001
//revised Aug 2001 (changes in function names)
//NOTE: OPEN SOURCE FOR ADVANCED JAMAGIC USERS ONLY!!!
//USE THIS AT YOUR OWN RISK!!!!!!
//If you do any changes (fixes, upgrades)
//to this code, please let me know!

//Draw some initial text and controls.

	mywindow=New Window(600,400,20,20,GetRGB(255,255,128),8,"Delete unused files from temporary directories v1.2");

	WriteLn(" Delete unused files from temporary directories.");
	WriteLn(" Please verify the list before hitting the OK Button!");

	mylist=New ListBox(mywindow,"",15,40,570,330,ListBox.SORT,ListBox.DISABLENOSCROLL,ListBox.VSCROLL);
	myokbutton=New Button(mywindow,"Please Wait",450,370,120,24);
	myokbutton.Disable();

//Initialize some variables
	Var pathchar="\";
	Var startdir="C:\PROGRAM FILES\JAMAGIC\";  //Jamagic directory, end it with a slash
	Var curdir=Disk.GetCurrentDirectory();  //can't erase this.project debug files ;)
	//add debug, release or other directories used for TEMPORARY files
	Var debgdir[1]="Debug";  
	Var debgdir[2]="Release";
	//
	Var inclusionlist=0;
	Var exclusionlist=0;
	Var i=0; Var j=0;
	Var ss=0;
	Var myFiles=0;
	Var FilesToDelete=0;
	Var deletecounter=0;
	Var EraseSignal=0;

	curdir=curdir.ToLowerCase();  //convert to lowercase
	
	For (i=1; i != 3; i++)
	{
		//add slashes to directories
		debgdir[i]=pathchar+debgdir[i]+pathchar;
		debgdir[i]=debgdir[i].ToLowerCase();  //lowercase directories
	}

//wait signal
CurWindow.SetCursor(CurWindow.Wait);

//Read the files
inclusionlist="*.rsj,temp.3dd";  //only temp.3dd and .rsj files
exclusionlist="";
myFiles=Disk.ListFiles(startdir, inclusionlist, exclusionlist, Disk.SUBDIRS); 

For (i=0; i<Disk.GetNFilenames; i++)
{
myFiles[i]=myFiles[i].ToLowerCase();  //to lowercase, please

	For (j=1; j != 3; j++)
	{
		If (myFiles[i].IndexOf(debgdir[j]) != -1)  //a temporary directory is found
		{
			If (myFiles[i].CharAt(myFiles[i].Length()-1) != pathchar)  //just files, not directories
			{
				If (myFiles[i].IndexOf(curdir) == -1)  //current project files can't be erased
				{
				deletecounter++;
				FilesToDelete[deletecounter]=myFiles[i];
				mylist.AddItem(FilesToDelete[deletecounter]);
				}  //endif check current directory
			}  //endif check only directories
		}  //endif indexof debugdir
	}  //next j
}  //next i

myFiles=0; //erasing this array... can be very big!

//Set the button if data is found
//if not, quit the application
If (deletecounter > 0)
{
myokbutton.SetText("OK TO Delete");
myokbutton.Enable();
myokbutton.SetFocus();
myokbutton.OnClick=Doclick; 
}
Else
{
myokbutton.SetText("Nothing here!");
myokbutton.Enable();
myokbutton.SetFocus();
myokbutton.OnClick=quitProg; 
}
//
CurWindow.SetCursor(CurWindow.ARROW);

//AHA! main loop
While(1)
{
If (EraseSignal == 1)  //button clicked
{
EraseSignal=0;

	For (i=0; i<deletecounter; i++)
	{
		If (Disk.Exist(FilesToDelete[i+1]))  //verifying that file exists
		{
		Disk.Delete(FilesToDelete[i+1]);  //deleting file OH NOOOO!!!!!
		}
	}
mylist.CLEAR();  //clearing listbox
}

//ending main While here...
}

//List of functions
//Doclick
Function DoClick(myokbutton)
{
myokbutton.Disable();  //To stop clicking-happy persons ;)
myokbutton.SetText("Done");
EraseSignal=1;
Return EraseSignal;
}
//quitProg
Function quitProg(myokbutton)
{
End(); //Nothing to erase, exit application
}
